
#ifndef IIR_ACCESS_SUBTYPE_DEFINITION_HH
#define IIR_ACCESS_SUBTYPE_DEFINITION_HH

// Copyright (c) 1996-1999 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@cliftonlabs.com

//---------------------------------------------------------------------------

#include "IIR_AccessTypeDefinition.hh"

class IIR_TypeDefinition;
class IIR_FunctionDeclaration;

class IIR_AccessSubtypeDefinition : public virtual IIR_AccessTypeDefinition{
  
public:
  virtual ~IIR_AccessSubtypeDefinition() {}

  virtual void set_designated_subtype( IIR_TypeDefinition *designated_type) = 0;
  virtual IIR_TypeDefinition *get_designated_subtype() = 0;

  virtual void set_resolution_function( IIR_FunctionDeclaration *resolution_function ) = 0;
  virtual IIR_FunctionDeclaration *get_resolution_function() = 0;
};
#endif
